- AnsibleFest
- Products
- Community
- Webinars & Training
- Blog

Documentation

# azure_rm_containerinstance – Manage an Azure Container Instance

New in version 2.5.

- Synopsis
- Requirements
- Parameters
- Notes
- See Also
- Examples
- Return Values
- Status

## Synopsis

- Create, update and delete an Azure Container Instance.

## Requirements

The below requirements are needed on the host that executes this module.

- python >= 2.7
- azure >= 2.0.0

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
ad_user string |  | Active Directory username. Use when authenticating with an Active Directory user rather than service principal.
adfs_authority_url string added in 2.6 |  | Azure AD authority url. Use when authenticating with Username/password, and has your own ADFS authority.
api_profile string added in 2.5 | Default: "latest" | Selects an API profile to use when communicating with Azure services. Default value of `latest` is appropriate for public clouds; future values will allow use with Azure Stack.
append_tags boolean | Choices: no yes ← | Use to control if tags field is canonical or just appends to existing tags. When canonical, any tags not found in the tags parameter will be removed from the object's metadata.
auth_source string added in 2.5 | Choices: auto cli credential_file env msi | Controls the source of the credentials to use for authentication. If not specified, ANSIBLE_AZURE_AUTH_SOURCE environment variable will be used and default to `auto` if variable is not defined. `auto` will follow the default precedence of module parameters -> environment variables -> default profile in credential file `~/.azure/credentials`. When set to `cli`, the credentials will be sources from the default Azure CLI profile. Can also be set via the `ANSIBLE_AZURE_AUTH_SOURCE` environment variable. When set to `msi`, the host machine must be an azure resource with an enabled MSI extension. `subscription_id` or the environment variable `AZURE_SUBSCRIPTION_ID` can be used to identify the subscription ID if the resource is granted access to more than one subscription, otherwise the first subscription is chosen. The `msi` was added in Ansible 2.6.
cert_validation_mode string added in 2.5 | Choices: ignore validate | Controls the certificate validation behavior for Azure endpoints. By default, all modules will validate the server certificate, but when an HTTPS proxy is in use, or against Azure Stack, it may be necessary to disable this behavior by passing `ignore`. Can also be set via credential file profile or the `AZURE_CERT_VALIDATION` environment variable.
client_id string |  | Azure client ID. Use when authenticating with a Service Principal.
cloud_environment string added in 2.4 | Default: "AzureCloud" | For cloud environments other than the US public cloud, the environment name (as defined by Azure Python SDK, eg, `AzureChinaCloud`, `AzureUSGovernment`), or a metadata discovery endpoint URL (required for Azure Stack). Can also be set via credential file profile or the `AZURE_CLOUD_ENVIRONMENT` environment variable.
containers - |  | List of containers. Required when creation.
| commands list added in 2.8 |  | List of commands to execute within the container instance in exec form. When updating existing container all existing commands will be replaced by new ones.
| cpu float | Default: 1 | The required number of CPU cores of the containers.
| environment_variables dictionary added in 2.8 |  | List of container environment variables. When updating existing container all existing variables will be replaced by new ones.
|  | is_secure boolean | Choices: no yes | Is variable secure.
|  | name string |  | Environment variable name.
|  | value string |  | Environment variable value.
| image - / required |  | The container image name.
| memory float | Default: 1.5 | The required memory of the containers in GB.
| name - / required |  | The name of the container instance.
| ports list |  | List of ports exposed within the container group.
dns_name_label string added in 2.8 |  | The Dns name label for the IP.
force_update boolean | Choices: no ← yes | Force update of existing container instance. Any update will result in deletion and recreation of existing containers.
ip_address - | Choices: public none ← | The IP address type of the container group. Default is `none` and creating an instance without public IP.
location - |  | Valid azure location. Defaults to location of the resource group.
name - / required |  | The name of the container group.
os_type - | Choices: linux ← windows | The OS type of containers.
password string |  | Active Directory user password. Use when authenticating with an Active Directory user rather than service principal.
ports list |  | List of ports exposed within the container group. This option is deprecated, using ports under containers".
profile string |  | Security profile found in ~/.azure/credentials file.
registry_login_server - |  | The container image registry login server.
registry_password - |  | The password to log in container image registry server.
registry_username - |  | The username to log in container image registry server.
resource_group - / required |  | Name of resource group.
restart_policy string added in 2.8 | Choices: always on_failure never | Restart policy for all containers within the container group.
secret string |  | Azure client secret. Use when authenticating with a Service Principal.
state - | Choices: absent present ← | Assert the state of the container instance. Use `present` to create or update an container instance and `absent` to delete it.
subscription_id string |  | Your Azure subscription Id.
tags dictionary |  | Dictionary of string:string pairs to assign as metadata to the object. Metadata tags on the object will be updated with any provided values. To remove tags set append_tags option to false.
tenant string |  | Azure tenant ID. Use when authenticating with a Service Principal.

## Notes

Note

- For authentication with Azure you can pass parameters, set environment variables, use a profile stored in ~/.azure/credentials, or log in before you run your tasks or playbook with `az login`.
- Authentication is also possible using a service principal or Active Directory user.
- To authenticate via service principal, pass subscription_id, client_id, secret and tenant or set environment variables AZURE_SUBSCRIPTION_ID, AZURE_CLIENT_ID, AZURE_SECRET and AZURE_TENANT.
- To authenticate via Active Directory user, pass ad_user and password, or set AZURE_AD_USER and AZURE_PASSWORD in the environment.
- Alternatively, credentials can be stored in ~/.azure/credentials. This is an ini file containing a [default] section and the following keys: subscription_id, client_id, secret and tenant or subscription_id, ad_user and password. It is also possible to add additional profiles. Specify the profile by passing profile or setting AZURE_PROFILE in the environment.

## See Also

See also

Sign in with Azure CLI
  How to authenticate using the `az login` command.

## Examples

    - name: Create sample container group
      azure_rm_containerinstance:
        resource_group: myResourceGroup
        name: myContainerInstanceGroup
        os_type: linux
        ip_address: public
        containers:
          - name: myContainer1
            image: httpd
            memory: 1.5
            ports:
              - 80
              - 81

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
id string | always | Resource ID. Sample: /subscriptions/xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx/resourceGroups/myResourceGroup/providers/Microsoft.ContainerInstance/containerGroups/aci1b6dd89
ip_address string | if address is public | Public IP Address of created container group. Sample: 175.12.233.11
provisioning_state string | always | Provisioning state of the container. Sample: Creating

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]
- This module is maintained by the Ansible Community. [community]

### Authors

- Zim Kalinowski (@zikalino)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.